package com.mudu.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.mudu.entity.ASafeRwzq;
import com.mudu.entity.dto.response.RwzqUuidResponse;

/**
 * (ASafeRwzq)表服务接口
 *
 * @author wu
 * @since 2024-03-18 16:58:08
 */
public interface ASafeRwzqService extends IService<ASafeRwzq> {


    /**
     * 获取巡查任务周期的最新一条id
     *
     * @return
     */
    RwzqUuidResponse getXcUuid();


    /**
     * 获取自查任务周期的最新一条id
     *
     * @return
     */
    RwzqUuidResponse getZcUuid();


    /**
     * 根据企业id和s_safe_fxd的fxdbh查询风险点的信息编号
     *
     * @param enterPriseId 企业id
     * @param fxdbh        风险点编号
     * @return
     */
    String findByEnIdFxd(String enterPriseId, String fxdbh);

    /**
     * 根据企业id和s_safe_fxd的fxdbh查询风险点的信息编号
     * @param enterPriseId 企业id
     * @param fxdbh        风险点编号
     * @return 市风险点编号
     */
    String findSfxdbhByEnIdFxd(String enterPriseId, String fxdbh);
}

