package com.mudu.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.mudu.entity.ASafeRwzq;
import com.mudu.entity.dto.response.RwzqUuidResponse;
import com.mudu.mapper.ASafeRwzqMapper;
import com.mudu.service.ASafeRwzqService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;

/**
 * (ASafeRwzq)表服务实现类
 *
 * @author wu
 * @since 2024-03-18 16:58:08
 */
@Service("aSafeRwzqService")
public class ASafeRwzqServiceImpl extends ServiceImpl<ASafeRwzqMapper, ASafeRwzq> implements ASafeRwzqService {

    @Resource
    private  ASafeRwzqMapper aSafeRwzqMapper;
    @Override
    public RwzqUuidResponse getXcUuid() {
        return aSafeRwzqMapper.getXcUuid();
    }

    @Override
    public RwzqUuidResponse getZcUuid() {
        return aSafeRwzqMapper.getZcUuid();
    }

    @Override
    public String findByEnIdFxd(String enterPriseId, String fxdbh) {
        return aSafeRwzqMapper.findByEnIdFxd(enterPriseId,fxdbh);
    }

    /**
     * 根据企业id和s_safe_fxd的fxdbh查询风险点的信息编号
     *
     * @param enterPriseId 企业id
     * @param fxdbh        风险点编号
     * @return 市风险点编号
     */
    @Override
    public String findSfxdbhByEnIdFxd(String enterPriseId, String fxdbh) {
        return aSafeRwzqMapper.findSfxdbhByEnIdFxd(enterPriseId,fxdbh);
    }
}

